//import libraries
import {
    world,
    Player
} from 'mojang-minecraft';

//prefix (change to your prefix)
const prefix = '-'

//your custom commands go here
function yourCommand(command, arg, text, player) {
    const playerName = player.name ?? player.nameTag; //get player name
    //text = is the whole massage
    //player = is the player
    //playerName = is player name
    //args = is the word you put after prefix and command
    //example "-c give diamond 64 1" (arg[0] = diamond, arg[1] = 64, arg[2] = 1, and soo on)

    switch (command) {
        case 'sudo': //if i type "-c hello" run this
            if (arg[0] == undefined) {
                runCmdEntity(`tellraw ${playerName} { "rawtext": [ { "text": "Please ender a name and a message" } ] }`, player);
            } else {
                runCmdEntity(`tellraw @a { "rawtext": [ { "text": "<${arg[0]}> ${arg[1]} ${arg[2]} ${arg[3]} ${arg[4]} ${arg[5]} ${arg[6]} ${arg[7]} ${arg[8]} ${arg[9]} ${arg[10]} ${arg[11]}${arg[12]} ${arg[13]} ${arg[14]} ${arg[15]} ${arg[16]}" } ] }`, player);
            }
            break;

        case 'gmc': //if i type "-gm" check argument
            if (haveTag(player, "op")) {
                runCmd(`gamemode c "${playerName}"`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permission!"}]}`, "overworld");
            }
            break;

        case 'op':
            if (arg[0] == playerName) {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":" §4you cant op yourself!"}]}`, "overworld");
            } else if (haveTag(player, "op")) {
                runCmd(`tag ${arg[0]} add op`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permission!"}]}`, "overworld");
            }
            break;

        case 'smite':
            if (haveTag(player, "op")) {
                runCmd(`execute ${arg[0]} ~ ~-4 ~ summon lightning_bolt`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permisson!"}]}`, "overworld");
            }
            break;

        case 'tp2p':
            if (haveTag(player, "op")) {
                runCmd(`tp ${playerName} ${arg[0]}`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permisson!"}]}`, "overworld");
            }
            break;

        case 'kill':
            if (haveTag(player, "op")) {
                runCmd(`damage ${arg[0]} 1000 void`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permisson!"}]}`, "overworld");
            }
            break;

        case 'gms':
            if (haveTag(player, "op")) {
                runCmd(`gamemode s ${playerName}`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permisson!"}]}`, "overworld");
            }
            break;

        case 'i':
            if (haveTag(player, "op")) {
                runCmd(`give "${playerName}" ${arg[0]} ${arg[1]}`, "overworld");
            } else {
                runCmd(`say you don't have op ${playerName}`, "overworld");
            }
            break;

        case 'sethub':
            if (haveTag(player, "op")) {
                runCmd(`execute ${playerName} ~ ~ ~ function hub`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permisson!"}]}`, "overworld");
            }
            break;

        case 'hub':
            runCmd(`tp ${playerName} @e[type=armor_stand,tag=sethub]`, "overworld");
            runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§2You have been teleported to the hub!"}]}`, "overworld");
            break;

        case 'heal':
            if (haveTag(player, "op")) {
                runCmd(`effect ${playerName} instant_health 1 255 true`, "overworld");
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§2You have been healed"}]}`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permisson!"}]}`, "overworld");
            }
            break;

        case `void`:
            if (haveTag(player, "op")) {
                runCmd(`execute ${arg[0]} ~ -64 ~ fill ~2 ~ ~-2 ~-2 ~320 ~2 air`, "overworld");
            } else {
                runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§4You have no permisson!"}]}`, "overworld");
            }
            break;

        case 'help':
            runCmd(`tellraw ${playerName} {"rawtext":[{"text":"§3§lcommand pack made by BraydenB\n-sudo: make another player say somthing else\n-gmc: gamemode c \n-op: op's a player for using op commands in these commands it does not op them in the same way as /op\n-tp2p: teleaport to the player mentioned \n-smite smite the target \n-gms: gamemode s \n-void: create a void hole below and above the target \n-kill: kills the target with the death message fell out of the world \n-i: /give \n-hub: teleaports to the hub \n-sethub: sets the hub \n-heal: heals you \n-help shows this \n§r§4§lMade by BraydenB"}]}`, "overworld");
            break;

        default: //if no command match do this
            runCmdEntity(`tellraw @s { "rawtext": [ { "text": "§4unknown command, no command with name ${command}" } ] }`, player);
    }
}





//run when player chat
world.events.beforeChat.subscribe(msg => {
    if (msg.message.substr(0, prefix.length) == prefix) {
        let args_ = msg.message.slice(prefix.length).trim().split(' '); //split command & argument from prefix
        let command = args_.shift().toLowerCase(); //split command and command argument
        msg.cancel = true; //cancel chat
        const player = msg.sender //get the player that using this chat
        const text = msg.message; //get original message
        yourCommand(command, args_, text, player);
    }
})


//test if player has a tag
//player = player, not player name
//tag = tag the player need
function haveTag(player, tag) {
    return player.hasTag(tag);
}


//run command from dimension
//cmd = your command
//dim = dimension, one of ( "overworld","nether","the end")
function runCmd(cmd, dim) {
    return world.getDimension(dim ?? "overworld").runCommand(cmd);
}
//run command from entity/player
//cmd = your command
//entity = player, not player name
function runCmdEntity(cmd, entity) {
    return entity.runCommand(cmd);
}


//run command from dimension then test error(if command run succsess then false)
//cmd = your command
//dim = dimension, one of( "overworld","nether","the end")
function testCmd(cmd, dim) {
    try {
        return {
            result: world.getDimension(dim ?? "overworld").runCommand(cmd),
            error: false
        }
    } catch (e) {
        return {
            result: JSON.parse(e),
            error: true
        }
    }
}
//same with above but from entity/player
//cmd = your command
//entity = player, not player name
function testCmdEntity(cmd, entity) {
    try {
        return {
            result: entity.runCommand(cmd),
            error: false
        }
    } catch (e) {
        return {
            result: JSON.parse(e),
            error: true
        }
    }
}


//get the text from command output run by dimension
//cmd = your command
//dim = dimension, one of ( "overworld","nether","the end")
function outCmd(cmd, dim) {
    return runCmd(cmd, dim ?? "overworld").statusMessage;
}
//get the text from command output run by entity/player
//cmd = your command
//entity = player, not player name
function outCmdEntity(cmd, entity) {
    return runCmdEntity(cmd, entity).statusMessage;
}